---
title: MediaDevices.getDisplayMedia()
slug: Web/API/MediaDevices/getDisplayMedia
tags:
  - API
  - Capture
  - Conference
  - Media
  - MediaDevices
  - Method
  - Reference
  - Screen Capture
  - Screen Capture API
  - Sharing
  - Video
  - display
  - getDisplayMedia
  - screen
---
<div>{{DefaultAPISidebar("Screen Capture API")}}</div>

<p><span class="seoSummary">The {{domxref("MediaDevices")}} interface's <code><strong>getDisplayMedia()</strong></code> method prompts the user to select and grant permission to capture the contents of a display or portion thereof (such as a window) as a {{domxref("MediaStream")}}.</span> The resulting stream can then be recorded using the <a href="/en-US/docs/Web/API/MediaStream_Recording_API">MediaStream Recording API</a> or transmitted as part of a <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a> session.</p>

<p>See <a href="/en-US/docs/Web/API/Screen_Capture_API/Using_Screen_Capture">Using the Screen Capture API</a> for more details and an example.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>promise</em> = navigator.mediaDevices.getDisplayMedia(<em>constraints</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>constraints</code> {{optional_inline}}</dt>
 <dd>An optional {{domxref("MediaStreamConstraints")}} object specifying requirements for the returned {{domxref("MediaStream")}}. Since <code>getDisplayMedia()</code> requires a video track, the returned stream will have one even if no video track is expressly requested by the <code>constraints</code> object.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves to a {{domxref("MediaStream")}} containing a video track whose contents come from a user-selected screen area, as well as an optional audio track.</p>

<div class="notecard note">
<p><strong>Note:</strong> Browser support for audio tracks varies, both in terms of whether or not they're supported at all by the media recorder and in terms of the which audio source or sourcoes are supported. Check the {{anch("Browser compatibility", "compatibility table")}} for details for each browser.</p>
</div>

<h3 id="Exceptions">Exceptions</h3>

<p>Rejections of the returned promise are made by passing a {{domxref("DOMException")}} error object to the promise's failure handler. Possible errors are:</p>

<dl>
 <dt>{{JSxRef("AbortError")}}</dt>
 <dd>An error or failure that doesn't match any of the other exceptions below occurred.</dd>
 <dt>{{JSxRef("InvalidStateError")}}</dt>
 <dd>The call to <code>getDisplayMedia()</code> was not made from code running due to a user action, such as an event handler. Another potential cause for this event: the {{domxref("document")}} in whose context <code>getDisplayMedia()</code> was called is not fully active; for example, perhaps it is not the frontmost tab.</dd>
 <dt>{{JSxRef("NotAllowedError")}}</dt>
 <dd>Permission to access a screen area was denied by the user, or the current browsing instance is not permitted access to screen sharing.</dd>
 <dt>{{JSxRef("NotFoundError")}}</dt>
 <dd>No sources of screen video are available for capture.</dd>
 <dt>{{JSxRef("NotReadableError")}}</dt>
 <dd>The user selected a screen, window, tab, or other source of screen data, but a hardware or operating system level error or lockout occurred, preventing the sharing of the selected source.</dd>
 <dt>{{JSxRef("OverconstrainedError")}}</dt>
 <dd>After creating the stream, applying the specified <code>constraints</code> fails because no compatible stream could be generated.</dd>
 <dt>{{JSxRef("TypeError")}}</dt>
 <dd>The specified <code>constraints</code> include constraints which are not permitted when calling <code>getDisplayMedia()</code>. These unsupported constraints are <code>advanced</code> and any constraints which in turn have a member named <code>min</code> or <code>exact</code>.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Privacy_and_security">Privacy and security</h3>

<p>Because <code>getDisplayMedia()</code> could be used in nefarious ways, it can be a source of significant privacy and security concerns. For that reason, the specification details measures browsers are required to take in order to fully support <code>getDisplayMedia()</code>.</p>

<ul>
 <li>The specified <code>constraints</code> can't be used to limit the options available to the user. Instead, they must be applied after the user chooses a source, in order to generate output that matches the constraints.</li>
 <li>The go-ahead permission to use <code>getDisplayMedia()</code> cannot be persisted for reuse. The user must be prompted for permission every time.</li>
 <li>The call to <code>getDisplayMedia()</code> must be made from code which is running in response to a user action, such as in an event handler.</li>
 <li>Browsers are encouraged to provide a warning to users about sharing displays or windows that contain browsers, and to keep a close eye on what other content might be getting captured and shown to other users.</li>
</ul>

<h2 id="Example">Example</h2>

<p>In the example below, a <code>startCapture()</code> method is created which initiates screen capture given a set of options specified by the <code>displayMediaOptions</code> parameter. The options are specified in the form of a {{domxref("MediaStreamConstraints")}} object which specifies the preferred stream configuration and the <a href="/en-US/docs/Web/API/Screen_Capture_API/Using_Screen_Capture#Visible_vs_logical_display_surfaces">display surface</a> from which video is to be captured.</p>

<pre class="brush: js">async function startCapture(displayMediaOptions) {
  let captureStream = null;

  try {
    captureStream = await navigator.mediaDevices.getDisplayMedia(displayMediaOptions);
  } catch(err) {
    console.error("Error: " + err);
  }
  return captureStream;
}</pre>

<p>This uses {{jsxref("await")}} to asynchronously wait for <code>getDisplayMedia()</code> to resolve with a {{domxref("MediaStream")}} which contains the display contents as requested by the specified options. The stream is then returned to the caller for use, perhaps for adding to a WebRTC call using {{domxref("RTCPeerConnection.addTrack()")}} to add the video track from the stream.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Screen Capture', '#dom-mediadevices-getdisplaymedia', 'MediaDevices.getDisplayMedia()')}}</td>
   <td>{{Spec2('Screen Capture')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MediaDevices.getDisplayMedia")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API">Screen Capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API/Using_Screen_Capture">Using the Screen Capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li>{{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}: Capturing media from a camera and/or microphone</li>
</ul>
